#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h>

extern int h_errno;

#define MAXBUF 80

void blad(char * message)
{
	fprintf(stderr, "%s\n", message);
	exit(1);
}

int isNumber(char * string)
{
	int i = 0;
	for (i = 0; string[i] != 0; ++i)
	{
		if (string[i] < '0' || string[i] > '9')
		{
			return 0;
		}
	}
	return 1;
}

int anyPort_to_int(char * string)
{
	FILE * potok;
        char buffer[MAXBUF];
	int readed;
	char * portStart;
	char * cp;

	if (isNumber(string))
	{
		portStart = string;
	} else {
		snprintf(buffer, sizeof(buffer), "getent services %s", string);
		potok = popen(buffer, "r");
		if (potok == NULL) blad("popen() error");
		if (feof(potok)) blad("can't find given port number");
		readed = fread(buffer, sizeof(char), sizeof(buffer), potok);
		if (ferror(potok)) blad("fread() error");
		if (readed == 0) blad("can't find given port number");
		buffer[readed - 1] = 0;

		for (cp = buffer; *cp != '/'; cp += sizeof(char))
		{
			if (*(cp - sizeof(char)) == ' ' && *cp >= '0' && *cp <= '9')
				portStart = cp;
		}
		cp = 0;
	}
	return atoi(portStart);
}

int main(int argc, char *argv[])
{
    struct sockaddr_in sAddr, klientAddr;
    int listensock;
    int sock_cli;
    int servPort;
    char buffer[25];
    int result;
    int nread;
    unsigned int klientAddrSize;

    if (argc != 2) {
       fprintf(stderr, "Uzycie: %s <Port>\n",argv[0]);
       exit(1);
    }

    listensock = socket(PF_INET, SOCK_STREAM, 0);
    if (listensock <0) {
       perror("serwer");
       exit(1);
    }
    servPort=anyPort_to_int(argv[1]);

    sAddr.sin_family = AF_INET;
    sAddr.sin_port = htons(servPort);
    sAddr.sin_addr.s_addr = INADDR_ANY;
    result = bind(listensock, (struct sockaddr *) &sAddr, sizeof(sAddr));
    if (result < 0) {
        perror("serwer");
        exit(1);
    }
    result = listen(listensock, 5);
    if (result < 0) {
        perror("serwer");
        exit(1);
    }
    klientAddrSize = sizeof(klientAddrSize);

    while (1) {
	  
        sock_cli = accept(listensock, (struct sockaddr *) &klientAddr, &klientAddrSize);
        if (sock_cli < 0) {
          perror("serwer");
          exit(1);
        }
	printf("[+] Obsluguje klienta %s:%i\n", inet_ntoa(klientAddr.sin_addr), ntohs(klientAddr.sin_port));
	while(1)
	{
		nread = read(sock_cli, buffer, MAXBUF-1);
		if (nread < 2)
			break;
		buffer[nread] = '\0';
		fprintf(stdout,"%s", buffer);
		write(sock_cli, buffer, nread);
	}
	printf("[-] Zakonczylem obsluge klienta.\n");
        close(sock_cli);
   }
}
